﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{  
       
    protected void Page_Load(object sender, EventArgs e)
    {
        WebHierarchicalDataGrid1.DataSource = WHDGDataSource();          
    }

    private DataSet WHDGDataSource()
    {
        DataSet ds = new DataSet();
        ds.Tables.Add(GridDataSource("Table1", 5, false));
        ds.Tables.Add(GridDataSource("Table2", 8, true));

        DataRelation dr = new DataRelation("id", ds.Tables["Table1"].Columns["id"], ds.Tables["Table2"].Columns["id"], false);

        ds.Relations.Add(dr);

        return ds;
    }

    private DataTable GridDataSource(string tableName, int numOfRecords, bool duplicate)
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable(tableName);
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "id";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);

        // Create second column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table. 
        table.Columns.Add(column);

        // Create third column.
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        if (!duplicate)
        {
            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = PrimaryKeyColumns;
        }
        else
        {

            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["Data"];
            table.PrimaryKey = PrimaryKeyColumns;
        }

        for (int i = 0; i <= numOfRecords; i++)
        {
            row = table.NewRow();
            row["id"] = i;
            row["Item"] = i + 2;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);

            if (duplicate)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = i + 20;
                row["Data"] = "Data " + i + 2;
                table.Rows.Add(row);

                row = table.NewRow();
                row["id"] = i;
                row["Item"] = i + 30;
                row["Data"] = "Data " + i + 3;
                table.Rows.Add(row);
            }
        }


        return table;

    }    
    
}